local gfx <const> = playdate.graphics

local focusPriority = {}

Camera = {
    pan = {
        x = 0,
        y = 0,
    },
}

cameraPanSystem = filteredSystem({ focusPriority = T.number, position = T.XyPair }, function(e, dt)
    if e.focusPriority >= focusPriority.priority then
        focusPriority.position = e.position
    end
end)

function cameraPanSystem:preProcess()
    focusPriority.priority = 0
    focusPriority.position = { x = 0, y = 0 }
end

function cameraPanSystem:postProcess()
    Camera.pan.x = math.max(0, focusPriority.position.x - 200)
    Camera.pan.y = math.min(0, focusPriority.position.y - 120)
    gfx.setDrawOffset(-Camera.pan.x, -Camera.pan.y)
end
